#include "WiFiEsp.h"

#include <SoftwareSerial.h> 
#define rxPin 3 
#define txPin 2 
SoftwareSerial esp01(txPin, rxPin); // SoftwareSerial NAME(TX, RX);

char ssid[] = "SK_WiFiGIGA40F7";    // your network SSID (name)
char pass[] = "1712037218";         // your network password
int status = WL_IDLE_STATUS;        // the Wifi radio's status

// https://api.openweathermap.org/data/2.5/weather?q=Seoul,KR&APPID=YOUR_API_KEY
const char* host = "api.openweathermap.org";
const String url = "/data/2.5/weather?q=Seoul,KR&APPID=YOUR_API_KEY";

WiFiEspClient client; // WiFiEspClient 객체 선언

// RSS 날씨 정보 저장 변수
String line = "";
bool weather_check = false;

// RSS 날씨 정보 수신에 소요되는 시간 확인용 변수
unsigned long int count_time = 0;
bool count_start = false;
int count_val = 0;

void get_weather() {
  Serial.println(F("Starting connection to server..."));
  if (client.connect(host, 80)) {
    Serial.println(F("Connected to server"));
    client.print("GET " + url + " HTTP/1.1\r\n" +  
                 "Host: " + host + "\r\n" +  
                 "Connection: close\r\n\r\n");
    weather_check = true;
    count_start = true;
  }
}

void setup() {
  Serial.begin(9600);  //시리얼모니터
  esp01.begin(9600);   //와이파이 시리얼
  WiFi.init(&esp01);   // initialize ESP module
  while ( status != WL_CONNECTED) {   // attempt to connect to WiFi network
    Serial.print(F("Attempting to connect to WPA SSID: "));
    Serial.println(ssid);
    status = WiFi.begin(ssid, pass);    // Connect to WPA/WPA2 network
  }
  Serial.println(F("You're connected to the network"));
  Serial.println();
  delay(1000);
  get_weather();
}

void check_client_available() {  // loop()함수 진입 및 스캔 테스트 코드
  if (count_start == true) {
    if (millis() - count_time >= 100) {
      count_time = millis();
      count_val++;
      Serial.print(".");
      if (count_val == 30) count_start = false;
    }
  }
}

bool receive_data = false;

void loop() {
  check_client_available();
  while(client.available()) { // 날씨 정보가 들어오는 동안
    char c = client.read();
    if(c == '{') receive_data = true; // { 데이터 저장 시작, '{'는 저장 안함
    else if (receive_data == true) line += c;
  }
  if (weather_check == true) {
    if (!client.connected()) {   // 날씨정보 수신 종료됐으면
      receive_data = false;
      Serial.println();
      Serial.println(F("Disconnecting from server..."));
      client.stop();
      Serial.println(line);
      Serial.println(F("weather data for parsing"));
      String description = json_parser(line, "description");
      Serial.print(F("description: ")); Serial.println(description);
      String pressure = json_parser(line, "pressure");
      Serial.print(F("pressure: ")); Serial.println(pressure);
      String wind = json_parser(line, "speed");
      Serial.print(F("wind: ")); Serial.println(wind);
      String Temp = json_parser(line, "temp");
      Serial.print(F("Temp: ")); Serial.println(Temp);
      line = "";
      weather_check = false;
    }
  }
} 

String json_parser(String s, String a) { 
  String val;
  if (s.indexOf(a) != -1) {
    int st_index = s.indexOf(a);
    int val_index = s.indexOf(':', st_index);
    if (s.charAt(val_index + 1) == '"') {
      int ed_index = s.indexOf('"', val_index + 2);
      val = s.substring(val_index + 2, ed_index);
    }
    else {
      int ed_index = s.indexOf(',', val_index + 1);
      val = s.substring(val_index + 1, ed_index);
    }
  } 
  else {
    Serial.print(a); Serial.println(F(" is not available"));
  }
  return val;
}
